Show only valid projects on issue form when the issue is a subtask

2020-05-08 13:01 - Dmitry Makurin 

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Issues Estimated time: 0.00 hour

Target version: 4.2.0   

Resolution: Fixed Affected version:  

Description

In r10587 were introduced cross project subtasks, you can select project of subtask based on system setting.

In r17217 were introduced selection project and its subprojects on new issue form. Basically it shows on new issue form subprojects

without taking into account setting for cross-project subtasks. So, even though subtask may have any project form will show only

current project and its subprojects or vice versa subtasks' project is disabled and nevertheless form will show subprojects.

Related patch fixes this behaviour. New issue form will show projects based on system setting if parent_issue_id field is present so

user can't select inappropriate project.

Associated revisions

Revision 20701 - 2021-01-01 01:59 - Go MAEDA

Show only valid projects on issue form when the issue is a subtask (#33419).

Patch by Marius BALTEANU.

Revision 20733 - 2021-02-01 05:22 - Go MAEDA

Fix project selector on global new issue page not showing all visible projects (#33419).

Patch by Marius BALTEANU.

History

#1 - 2020-05-16 05:17 - Go MAEDA

- Tracker changed from Patch to Defect

- Category set to Issues

- Target version set to Candidate for next major release

#2 - 2020-05-16 05:23 - Go MAEDA

- Status changed from New to Confirmed

#3 - 2020-12-12 12:15 - Marius BĂLTEANU

- Assignee set to Marius BĂLTEANU

#4 - 2020-12-21 21:58 - Marius BĂLTEANU

- File 0001-Take-into-account-the-setting-Setting.cross_project_.patch added

- Subject changed from Subtasks' project on new issue form to Show only valid projects on issue form when the issue is a subtask

- Assignee deleted (Marius BĂLTEANU)

I made a patch (inspired from Dmitry's work) that implements this feature.

The patch also changes my initial implementation (r17217) in order to move the logic from model to issue helper.

#5 - 2020-12-30 05:14 - Go MAEDA

- Target version changed from Candidate for next major release to 4.2.0

Setting the target version to 4.2.0.
#6 - 2021-01-01 01:59 - Go MAEDA

- Status changed from Confirmed to Closed

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you.

#7 - 2021-01-27 05:52 - Yuichi HARADA

When the new issue input form is displayed with "Projects(#top-menu) > Issues > New issue", the projects that can be selected are narrowed down

even though the issue to be created is not a subtask. I think it's due to app/views/issues/_form.html.erb@20701, is this appropriate?

#8 - 2021-01-27 17:56 - Marius BĂLTEANU

- Status changed from Closed to Reopened

- Assignee changed from Go MAEDA to Marius BĂLTEANU

Yuichi HARADA wrote:

When the new issue input form is displayed with "Projects(#top-menu) > Issues > New issue", the projects that can be selected are narrowed

down even though the issue to be created is not a subtask. I think it's due to app/views/issues/_form.html.erb@20701, is this appropriate?

 Let me take a look.

#9 - 2021-01-28 07:51 - Marius BĂLTEANU

- File 0001-Fix-project-selector-on-global-new-issue-page-not-sh.patch added

Indeed, the project selector contains only descendant projects of the selected project. The attached patch should fix this, Yuichi, please test with it.

#10 - 2021-01-28 08:10 - Yuichi HARADA

Marius BALTEANU wrote:

Indeed, the project selector contains only descendant projects of the selected project. The attached patch should fix this, Yuichi, please test with

it.

 Thanks for creating a patch. I will test it, so please wait for a while.

#11 - 2021-01-29 01:54 - Yuichi HARADA

Marius BALTEANU wrote:

Indeed, the project selector contains only descendant projects of the selected project. The attached patch should fix this, Yuichi, please test with

it.

 Marius, I confirmed your patch and test. I think it's good.

#12 - 2021-01-31 21:29 - Marius BĂLTEANU

- Assignee changed from Marius BĂLTEANU to Go MAEDA

#13 - 2021-02-01 05:22 - Go MAEDA

- Status changed from Reopened to Closed

Committed the patch 0001-Fix-project-selector-on-global-new-issue-page-not-sh.patch in r20733.

#14 - 2021-02-24 20:12 - Marius BĂLTEANU

- Status changed from Closed to Reopened

I have found another issue with the current implementation, the project selector dissapears after you select a project without children.

To reproduce:

- Open the new issue page from a project with children

- Observe that the project selector shows the children as expected
- Select a project without children

- Observe that the project selector disappear.

The cause is that the issue project is used to look for children (which changes when you select another project in the dropdown) instead of context

project (which remains the same).

To keep the code simple, I think it's better to just show the project tree instead of self and descendant. I had some cases when I wanted to create an

issue on the parent project.

What do you think? I've opened a new issue for this to track the change (#34798).

#15 - 2021-02-26 07:58 - Mizuki ISHIKAWA

- File bug.gif added

Marius BALTEANU wrote:

I have found another issue with the current implementation, the project selector dissapears after you select a project without children.

 I was just trying to make a issue to report this probrem.

I will attach the Gif image I made for that explanation.

#16 - 2021-03-23 21:55 - Marius BĂLTEANU

I've posted a patch to #34798 which should fix the issue reported by me in my previous comment.

#17 - 2021-03-25 03:17 - Mizuki ISHIKAWA

Marius BALTEANU wrote:

I've posted a patch to #34798 which should fix the issue reported by me in my previous comment.

 It looks like the patch was committed in #34798#note-7.

I was able to confirm that the problem was solved in my environment as well.

#18 - 2021-03-25 03:30 - Go MAEDA

- Status changed from Reopened to Closed

Marius BALTEANU wrote:

I have found another issue with the current implementation, the project selector dissapears after you select a project without children.

To reproduce:

- Open the new issue page from a project with children

- Observe that the project selector shows the children as expected

- Select a project without children

- Observe that the project selector disappear.

 Fixed by #34798.

Files

subtasks_project_on_new_issue_form.patch 6.09 KB 2020-05-08 Dmitry Makurin 

0001-Take-into-account-the-setting-Setting.cross_project_.patch 8.53 KB 2020-12-21 Marius BĂLTEANU

0001-Fix-project-selector-on-global-new-issue-page-not-sh.patch 1.73 KB 2021-01-28 Marius BĂLTEANU

bug.gif 453 KB 2021-02-26 Mizuki ISHIKAWA
